Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/BDY/bdydta.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/BDY/bdydta.F90	(revision 12062)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/BDY/bdydta.F90	(revision 12143)
@@ -449,389 +405,290 @@
       IF(lwp) WRITE(numout,*) ''
 
-      ! Set nn_dta
-      DO jbdy = 1, nb_bdy
-         nn_dta(jbdy) = MAX(   nn_dyn2d_dta  (jbdy)    &
-            &                , nn_dyn3d_dta  (jbdy)    &
-            &                , nn_tra_dta    (jbdy)    &
-#if defined key_si3
-            &                , nn_ice_dta    (jbdy)    &
-#endif
-                              )
-         IF(nn_dta(jbdy) > 1)   nn_dta(jbdy) = 1
-      END DO
-
-      ! Work out upper bound of how many fields there are to read in and allocate arrays
-      ! ---------------------------------------------------------------------------
-      ALLOCATE( nb_bdy_fld(nb_bdy) )
-      nb_bdy_fld(:) = 0
-      DO jbdy = 1, nb_bdy         
-         IF( cn_dyn2d(jbdy) /= 'none' .AND. ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) ) THEN
-            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 3
-         ENDIF
-         IF( cn_dyn3d(jbdy) /= 'none' .AND. nn_dyn3d_dta(jbdy) == 1 ) THEN
-            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 2
-         ENDIF
-         IF( cn_tra(jbdy) /= 'none' .AND. nn_tra_dta(jbdy) == 1  ) THEN
-            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 2
-         ENDIF
-#if defined key_si3
-         IF( cn_ice(jbdy) /= 'none' .AND. nn_ice_dta(jbdy) == 1  ) THEN
-            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 3
-         ENDIF
-#endif               
-         IF(lwp) WRITE(numout,*) 'Maximum number of files to open =', nb_bdy_fld(jbdy)
-      END DO            
-
-      nb_bdy_fld_sum = SUM( nb_bdy_fld )
-
-      ALLOCATE( bf(nb_bdy_fld_sum), STAT=ierror )
+      ALLOCATE( bf(jpbdyfld,nb_bdy), STAT=ierror )
       IF( ierror > 0 ) THEN   
          CALL ctl_stop( 'bdy_dta: unable to allocate bf structure' )   ;   RETURN  
       ENDIF
-      ALLOCATE( blf_i(nb_bdy_fld_sum), STAT=ierror )
-      IF( ierror > 0 ) THEN   
-         CALL ctl_stop( 'bdy_dta: unable to allocate blf_i structure' )   ;   RETURN  
-      ENDIF
-      ALLOCATE( nbmap_ptr(nb_bdy_fld_sum), STAT=ierror )
-      IF( ierror > 0 ) THEN   
-         CALL ctl_stop( 'bdy_dta: unable to allocate nbmap_ptr structure' )   ;   RETURN  
-      ENDIF
-      ALLOCATE( ilen1(nb_bdy_fld_sum), ilen3(nb_bdy_fld_sum) ) 
-      ALLOCATE( ibdy(nb_bdy_fld_sum) ) 
-      ALLOCATE( igrid(nb_bdy_fld_sum) ) 
-
+      bf(:,:)%clrootname = 'NOT USED'   ! default definition used as a flag in fld_read to do nothing.
+      bf(:,:)%lzint      = .FALSE.      ! default definition
+      bf(:,:)%ltotvel    = .FALSE.      ! default definition
+ 
       ! Read namelists
       ! --------------
       REWIND(numnam_cfg)
-      jfld = 0 
-      DO jbdy = 1, nb_bdy         
-         IF( nn_dta(jbdy) == 1 ) THEN
-            REWIND(numnam_ref)
-            READ  ( numnam_ref, nambdy_dta, IOSTAT = ios, ERR = 901)
-901         IF( ios /= 0 )   CALL ctl_nam ( ios , 'nambdy_dta in reference namelist', lwp )
+      DO jbdy = 1, nb_bdy
+
+         WRITE(ctmp1, '(a,i2)') 'BDY number ', jbdy
+         WRITE(ctmp2, '(a,i2)') 'block nambdy_dta number ', jbdy
+
+         ! There is only one nambdy_dta block in namelist_ref -> use it for each bdy so we do a rewind 
+         REWIND(numnam_ref)
+         READ  ( numnam_ref, nambdy_dta, IOSTAT = ios, ERR = 901)
+901      IF( ios /= 0 )   CALL ctl_nam ( ios , 'nambdy_dta in reference namelist' )
+
+         !   by-pass nambdy_dta reading if no input data used in this bdy   
+         IF(       ( dta_bdy(jbdy)%lneed_dyn2d .AND. MOD(nn_dyn2d_dta(jbdy),2) == 1 )   &
+            & .OR. ( dta_bdy(jbdy)%lneed_dyn3d .AND.     nn_dyn3d_dta(jbdy)    == 1 )   &
+            & .OR. ( dta_bdy(jbdy)%lneed_tra   .AND.       nn_tra_dta(jbdy)    == 1 )   &
+            & .OR. ( dta_bdy(jbdy)%lneed_ice   .AND.       nn_ice_dta(jbdy)    == 1 )   )   THEN
+            ! WARNING: we don't do a rewind here, each bdy reads its own nambdy_dta block one after another
             READ  ( numnam_cfg, nambdy_dta, IOSTAT = ios, ERR = 902 )
-902         IF( ios >  0 )   CALL ctl_nam ( ios , 'nambdy_dta in configuration namelist', lwp )
-            IF(lwm) WRITE( numond, nambdy_dta )
-
-            cn_dir_array(jbdy) = cn_dir
-            ln_full_vel_array(jbdy) = ln_full_vel
-
-            nblen => idx_bdy(jbdy)%nblen
-            nblenrim => idx_bdy(jbdy)%nblenrim
-            dta => dta_bdy(jbdy)
-            dta%nread(2) = 0
-
-            ! Only read in necessary fields for this set.
-            ! Important that barotropic variables come first.
-            IF( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) THEN 
-
-               IF( dta%ll_ssh ) THEN 
-                  if(lwp) write(numout,*) '++++++ reading in ssh field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_ssh
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-                  dta%nread(2) = dta%nread(2) + 1
-               ENDIF
-
-               IF( dta%ll_u2d .and. .not. ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in u2d field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_u2d
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 2
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-                  dta%nread(2) = dta%nread(2) + 1
-               ENDIF
-
-               IF( dta%ll_v2d .and. .not. ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in v2d field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_v2d
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 3
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = 1
-                  dta%nread(2) = dta%nread(2) + 1
-               ENDIF
-
-            ENDIF
-
-            ! read 3D velocities if baroclinic velocities require OR if
-            ! barotropic velocities required and ln_full_vel set to .true.
-            IF( nn_dyn3d_dta(jbdy) == 1 .OR. &
-           &  ( ln_full_vel_array(jbdy) .AND. ( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 ) ) ) THEN
-
-               IF( dta%ll_u3d .OR. ( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in u3d field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_u3d
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 2
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = jpk
-                  IF( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) dta%nread(2) = dta%nread(2) + 1
-               ENDIF
-
-               IF( dta%ll_v3d .OR. ( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in v3d field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_v3d
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 3
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = jpk
-                  IF( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) dta%nread(2) = dta%nread(2) + 1
-               ENDIF
-
-            ENDIF
-
-            ! temperature and salinity
-            IF( nn_tra_dta(jbdy) == 1 ) THEN
-
-               IF( dta%ll_tem ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in tem field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_tem
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = jpk
-               ENDIF
-
-               IF( dta%ll_sal ) THEN
-                  if(lwp) write(numout,*) '++++++ reading in sal field'
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_sal
-                  ibdy(jfld) = jbdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = jpk
-               ENDIF
-
-            ENDIF
+902         IF( ios >  0 )   CALL ctl_nam ( ios , 'nambdy_dta in configuration namelist' )
+            IF(lwm) WRITE( numond, nambdy_dta )           
+         ENDIF
+
+         ! get the number of ice categories in bdy data file (use a_i information to do this)
+         ipl = jpl   ! default definition
+         IF( dta_bdy(jbdy)%lneed_ice ) THEN    ! if we need ice bdy data
+            IF( nn_ice_dta(jbdy) == 1 ) THEN   ! if we get ice bdy data from netcdf file
+               CALL fld_fill(  bf(jp_bdya_i,jbdy:jbdy), bn_a_i, cn_dir, 'bdy_dta', 'a_i'//' '//ctmp1, ctmp2 )   ! use namelist info
+               CALL fld_clopn( bf(jp_bdya_i,jbdy), nyear, nmonth, nday )   ! not a problem when we call it again after
+               idvar = iom_varid( bf(jp_bdya_i,jbdy)%num, bf(jp_bdya_i,jbdy)%clvar, kndims=indims, kdimsz=i4dimsz, lduld=lluld )
+               IF( indims == 4 .OR. ( indims == 3 .AND. .NOT. lluld ) ) THEN   ;   ipl = i4dimsz(3)   ! xylt or xyl
+               ELSE                                                            ;   ipl = 1            ! xy or xyt
+               ENDIF
+               bf(jp_bdya_i,jbdy)%clrootname = 'NOT USED'   ! reset to default value as this subdomain may not need to read this bdy
+            ENDIF
+         ENDIF
 
 #if defined key_si3
-            ! sea ice
-            IF( nn_ice_dta(jbdy) == 1 ) THEN
-               ! Test for types of ice input (1cat or Xcat) 
-               ! Build file name to find dimensions 
-               clname=TRIM( cn_dir )//TRIM(bn_a_i%clname)
-               IF( .NOT. bn_a_i%ln_clim ) THEN   
-                                                  WRITE(clname, '(a,"_y",i4.4)' ) TRIM( clname ), nyear    ! add year
-                  IF( bn_a_i%cltype /= 'yearly' ) WRITE(clname, '(a,"m" ,i2.2)' ) TRIM( clname ), nmonth   ! add month
-               ELSE
-                  IF( bn_a_i%cltype /= 'yearly' ) WRITE(clname, '(a,"_m",i2.2)' ) TRIM( clname ), nmonth   ! add month
-               ENDIF
-               IF( bn_a_i%cltype == 'daily' .OR. bn_a_i%cltype(1:4) == 'week' ) &
-               &                                  WRITE(clname, '(a,"d" ,i2.2)' ) TRIM( clname ), nday     ! add day
+         IF( .NOT.ln_pnd ) THEN
+            rn_ice_apnd = 0. ; rn_ice_hpnd = 0.
+            CALL ctl_warn( 'rn_ice_apnd & rn_ice_hpnd = 0 when no ponds' )
+         ENDIF
+#endif
+
+         ! temp, salt, age and ponds of incoming ice
+         rice_tem (jbdy) = rn_ice_tem
+         rice_sal (jbdy) = rn_ice_sal
+         rice_age (jbdy) = rn_ice_age
+         rice_apnd(jbdy) = rn_ice_apnd
+         rice_hpnd(jbdy) = rn_ice_hpnd
+         
+         
+         DO jfld = 1, jpbdyfld
+
+            ! =====================
+            !          ssh 
+            ! =====================
+            IF( jfld == jp_bdyssh ) THEN
+               cl3 = 'ssh'
+               igrd = 1                                                    ! T point
+               ipk = 1                                                     ! surface data
+               llneed = dta_bdy(jbdy)%lneed_ssh                            ! dta_bdy(jbdy)%ssh will be needed
+               llread = MOD(nn_dyn2d_dta(jbdy),2) == 1                     ! get data from NetCDF file
+               bf_alias => bf(jp_bdyssh,jbdy:jbdy)                         ! alias for ssh structure of bdy number jbdy
+               bn_alias => bn_ssh                                          ! alias for ssh structure of nambdy_dta 
+               iszdim = idx_bdy(jbdy)%nblenrim(igrd)                       ! length of this bdy on this MPI processus : used only on the rim
+            ENDIF
+            ! =====================
+            !         dyn2d
+            ! =====================
+            IF( jfld == jp_bdyu2d ) THEN
+               cl3 = 'u2d'
+               igrd = 2                                                    ! U point
+               ipk = 1                                                     ! surface data
+               llneed = dta_bdy(jbdy)%lneed_dyn2d                          ! dta_bdy(jbdy)%ssh will be needed
+               llread = .NOT. ln_full_vel .AND. MOD(nn_dyn2d_dta(jbdy),2) == 1   ! don't get u2d from u3d and read NetCDF file
+               bf_alias => bf(jp_bdyu2d,jbdy:jbdy)                         ! alias for u2d structure of bdy number jbdy
+               bn_alias => bn_u2d                                          ! alias for u2d structure of nambdy_dta
+               IF( ln_full_vel ) THEN  ;   iszdim = idx_bdy(jbdy)%nblen(igrd)      ! will be computed from u3d -> need on the full bdy
+               ELSE                    ;   iszdim = idx_bdy(jbdy)%nblenrim(igrd)   ! used only on the rim
+               ENDIF
+            ENDIF
+            IF( jfld == jp_bdyv2d ) THEN
+               cl3 = 'v2d'
+               igrd = 3                                                    ! V point
+               ipk = 1                                                     ! surface data
+               llneed = dta_bdy(jbdy)%lneed_dyn2d                          ! dta_bdy(jbdy)%ssh will be needed
+               llread = .NOT. ln_full_vel .AND. MOD(nn_dyn2d_dta(jbdy),2) == 1   ! don't get v2d from v3d and read NetCDF file
+               bf_alias => bf(jp_bdyv2d,jbdy:jbdy)                         ! alias for v2d structure of bdy number jbdy
+               bn_alias => bn_v2d                                          ! alias for v2d structure of nambdy_dta 
+               IF( ln_full_vel ) THEN  ;   iszdim = idx_bdy(jbdy)%nblen(igrd)      ! will be computed from v3d -> need on the full bdy
+               ELSE                    ;   iszdim = idx_bdy(jbdy)%nblenrim(igrd)   ! used only on the rim
+               ENDIF
+            ENDIF
+            ! =====================
+            !         dyn3d
+            ! =====================
+            IF( jfld == jp_bdyu3d ) THEN
+               cl3 = 'u3d'
+               igrd = 2                                                    ! U point
+               ipk = jpk                                                   ! 3d data
+               llneed = dta_bdy(jbdy)%lneed_dyn3d .OR.               &     ! dta_bdy(jbdy)%u3d will be needed
+                  &   ( dta_bdy(jbdy)%lneed_dyn2d .AND. ln_full_vel )      !   u3d needed to compute u2d
+               llread = nn_dyn3d_dta(jbdy) == 1                            ! get data from NetCDF file
+               bf_alias => bf(jp_bdyu3d,jbdy:jbdy)                         ! alias for u3d structure of bdy number jbdy
+               bn_alias => bn_u3d                                          ! alias for u3d structure of nambdy_dta 
+               iszdim = idx_bdy(jbdy)%nblen(igrd)                          ! length of this bdy on this MPI processus
+           ENDIF
+            IF( jfld == jp_bdyv3d ) THEN
+               cl3 = 'v3d'
+               igrd = 3                                                    ! V point
+               ipk = jpk                                                   ! 3d data
+               llneed = dta_bdy(jbdy)%lneed_dyn3d .OR.               &     ! dta_bdy(jbdy)%v3d will be needed
+                  &   ( dta_bdy(jbdy)%lneed_dyn2d .AND. ln_full_vel )      !   v3d needed to compute v2d
+               llread = nn_dyn3d_dta(jbdy) == 1                            ! get data from NetCDF file
+               bf_alias => bf(jp_bdyv3d,jbdy:jbdy)                         ! alias for v3d structure of bdy number jbdy
+               bn_alias => bn_v3d                                          ! alias for v3d structure of nambdy_dta 
+               iszdim = idx_bdy(jbdy)%nblen(igrd)                          ! length of this bdy on this MPI processus
+           ENDIF
+
+            ! =====================
+            !          tra
+            ! =====================
+            IF( jfld == jp_bdytem ) THEN
+               cl3 = 'tem'
+               igrd = 1                                                    ! T point
+               ipk = jpk                                                   ! 3d data
+               llneed = dta_bdy(jbdy)%lneed_tra                            ! dta_bdy(jbdy)%tem will be needed
+               llread = nn_tra_dta(jbdy) == 1                              ! get data from NetCDF file
+               bf_alias => bf(jp_bdytem,jbdy:jbdy)                         ! alias for ssh structure of bdy number jbdy
+               bn_alias => bn_tem                                          ! alias for ssh structure of nambdy_dta 
+               iszdim = idx_bdy(jbdy)%nblen(igrd)                          ! length of this bdy on this MPI processus
+            ENDIF
+            IF( jfld == jp_bdysal ) THEN
+               cl3 = 'sal'
+               igrd = 1                                                    ! T point
+               ipk = jpk                                                   ! 3d data
+               llneed = dta_bdy(jbdy)%lneed_tra                            ! dta_bdy(jbdy)%sal will be needed
+               llread = nn_tra_dta(jbdy) == 1                              ! get data from NetCDF file
+               bf_alias => bf(jp_bdysal,jbdy:jbdy)                         ! alias for ssh structure of bdy number jbdy
+               bn_alias => bn_sal                                          ! alias for ssh structure of nambdy_dta 
+               iszdim = idx_bdy(jbdy)%nblen(igrd)                          ! length of this bdy on this MPI processus
+            ENDIF
+
+            ! =====================
+            !          ice
+            ! =====================
+            IF(  jfld == jp_bdya_i .OR. jfld == jp_bdyh_i .OR. jfld == jp_bdyh_s .OR. &
+               & jfld == jp_bdyt_i .OR. jfld == jp_bdyt_s .OR. jfld == jp_bdytsu .OR. &
+               & jfld == jp_bdys_i .OR. jfld == jp_bdyaip .OR. jfld == jp_bdyhip      ) THEN
+               igrd = 1                                                    ! T point
+               ipk = ipl                                                   ! jpl-cat data
+               llneed = dta_bdy(jbdy)%lneed_ice                            ! ice will be needed
+               llread = nn_ice_dta(jbdy) == 1                              ! get data from NetCDF file
+               iszdim = idx_bdy(jbdy)%nblen(igrd)                          ! length of this bdy on this MPI processus
+            ENDIF
+            IF( jfld == jp_bdya_i ) THEN
+               cl3 = 'a_i'
+               bf_alias => bf(jp_bdya_i,jbdy:jbdy)                         ! alias for a_i structure of bdy number jbdy
+               bn_alias => bn_a_i                                          ! alias for a_i structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdyh_i ) THEN
+               cl3 = 'h_i'
+               bf_alias => bf(jp_bdyh_i,jbdy:jbdy)                         ! alias for h_i structure of bdy number jbdy
+               bn_alias => bn_h_i                                          ! alias for h_i structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdyh_s ) THEN
+               cl3 = 'h_s'
+               bf_alias => bf(jp_bdyh_s,jbdy:jbdy)                         ! alias for h_s structure of bdy number jbdy
+               bn_alias => bn_h_s                                          ! alias for h_s structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdyt_i ) THEN
+               cl3 = 't_i'
+               bf_alias => bf(jp_bdyt_i,jbdy:jbdy)                         ! alias for t_i structure of bdy number jbdy
+               bn_alias => bn_t_i                                          ! alias for t_i structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdyt_s ) THEN
+               cl3 = 't_s'
+               bf_alias => bf(jp_bdyt_s,jbdy:jbdy)                         ! alias for t_s structure of bdy number jbdy
+               bn_alias => bn_t_s                                          ! alias for t_s structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdytsu ) THEN
+               cl3 = 'tsu'
+               bf_alias => bf(jp_bdytsu,jbdy:jbdy)                         ! alias for tsu structure of bdy number jbdy
+               bn_alias => bn_tsu                                          ! alias for tsu structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdys_i ) THEN
+               cl3 = 's_i'
+               bf_alias => bf(jp_bdys_i,jbdy:jbdy)                         ! alias for s_i structure of bdy number jbdy
+               bn_alias => bn_s_i                                          ! alias for s_i structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdyaip ) THEN
+               cl3 = 'aip'
+               bf_alias => bf(jp_bdyaip,jbdy:jbdy)                         ! alias for aip structure of bdy number jbdy
+               bn_alias => bn_aip                                          ! alias for aip structure of nambdy_dta 
+            ENDIF
+            IF( jfld == jp_bdyhip ) THEN
+               cl3 = 'hip'
+               bf_alias => bf(jp_bdyhip,jbdy:jbdy)                         ! alias for hip structure of bdy number jbdy
+               bn_alias => bn_hip                                          ! alias for hip structure of nambdy_dta 
+            ENDIF
+
+            IF( llneed .AND. iszdim > 0 ) THEN                             ! dta_bdy(jbdy)%xxx will be needed
+               !                                                           !   -> must be associated with an allocated target
+               ALLOCATE( bf_alias(1)%fnow( iszdim, 1, ipk ) )              ! allocate the target
                !
-               CALL iom_open  ( clname, inum )
-               id1 = iom_varid( inum, bn_a_i%clvar, kdimsz=kdimsz, kndims=kndims, ldstop = .FALSE. )
-               CALL iom_close ( inum )
-
-      	       IF ( kndims == 4 ) THEN
-                 nice_cat = kdimsz(4)   ! Xcat input
-               ELSE
-                 nice_cat = 1           ! 1cat input      
-               ENDIF
-               ! End test
-
-               IF( dta%ll_a_i ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_a_i
-                  ibdy(jfld)  = jbdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = nice_cat
-               ENDIF
-
-               IF( dta%ll_h_i ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_h_i
-                  ibdy(jfld)  = jbdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = nice_cat
-               ENDIF
-
-               IF( dta%ll_h_s ) THEN
-                  jfld = jfld + 1
-                  blf_i(jfld) = bn_h_s
-                  ibdy(jfld)  = jbdy
-                  igrid(jfld) = 1
-                  ilen1(jfld) = nblen(igrid(jfld))
-                  ilen3(jfld) = nice_cat
-               ENDIF
-
-            ENDIF
-#endif
-            ! Recalculate field counts
-            !-------------------------
-            IF( jbdy == 1 ) THEN 
-               nb_bdy_fld_sum = 0
-               nb_bdy_fld(jbdy) = jfld
-               nb_bdy_fld_sum     = jfld              
-            ELSE
-               nb_bdy_fld(jbdy) = jfld - nb_bdy_fld_sum
-               nb_bdy_fld_sum = nb_bdy_fld_sum + nb_bdy_fld(jbdy)
-            ENDIF
-
-            dta%nread(1) = nb_bdy_fld(jbdy)
-
-         ENDIF ! nn_dta == 1
-      ENDDO ! jbdy
-
-      DO jfld = 1, nb_bdy_fld_sum
-         ALLOCATE( bf(jfld)%fnow(ilen1(jfld),1,ilen3(jfld)) )
-         IF( blf_i(jfld)%ln_tint ) ALLOCATE( bf(jfld)%fdta(ilen1(jfld),1,ilen3(jfld),2) )
-         nbmap_ptr(jfld)%ptr => idx_bdy(ibdy(jfld))%nbmap(:,igrid(jfld))
-         nbmap_ptr(jfld)%ll_unstruc = ln_coords_file(ibdy(jfld))
-      ENDDO
-
-      ! fill bf with blf_i and control print
-      !-------------------------------------
-      jstart = 1
-      DO jbdy = 1, nb_bdy
-         jend = jstart - 1 + nb_bdy_fld(jbdy) 
-         CALL fld_fill( bf(jstart:jend), blf_i(jstart:jend), cn_dir_array(jbdy), 'bdy_dta',   &
-         &              'open boundary conditions', 'nambdy_dta' )
-         jstart = jend + 1
-      ENDDO
-
-      DO jfld = 1, nb_bdy_fld_sum
-         bf(jfld)%igrd = igrid(jfld)
-         bf(jfld)%ibdy = ibdy(jfld)
-      ENDDO
-
-      ! Initialise local boundary data arrays
-      ! nn_xxx_dta=0 : allocate space - will be filled from initial conditions later
-      ! nn_xxx_dta=1 : point to "fnow" arrays
-      !-------------------------------------
-
-      jfld = 0
-      DO jbdy=1, nb_bdy
-
-         nblen => idx_bdy(jbdy)%nblen
-         dta => dta_bdy(jbdy)
-
-         if(lwp) then
-            write(numout,*) '++++++ dta%ll_ssh = ',dta%ll_ssh
-            write(numout,*) '++++++ dta%ll_u2d = ',dta%ll_u2d
-            write(numout,*) '++++++ dta%ll_v2d = ',dta%ll_v2d
-            write(numout,*) '++++++ dta%ll_u3d = ',dta%ll_u3d
-            write(numout,*) '++++++ dta%ll_v3d = ',dta%ll_v3d
-            write(numout,*) '++++++ dta%ll_tem = ',dta%ll_tem
-            write(numout,*) '++++++ dta%ll_sal = ',dta%ll_sal
-         endif
-
-         IF ( nn_dyn2d_dta(jbdy) == 0 .or. nn_dyn2d_dta(jbdy) == 2 ) THEN
-            if(lwp) write(numout,*) '++++++ dta%ssh/u2d/u3d allocated space'
-            IF( dta%ll_ssh ) ALLOCATE( dta%ssh(nblen(1)) )
-            IF( dta%ll_u2d ) ALLOCATE( dta%u2d(nblen(2)) )
-            IF( dta%ll_v2d ) ALLOCATE( dta%v2d(nblen(3)) )
-         ENDIF
-         IF ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) THEN
-            IF( dta%ll_ssh ) THEN
-               if(lwp) write(numout,*) '++++++ dta%ssh pointing to fnow'
-               jfld = jfld + 1
-               dta%ssh => bf(jfld)%fnow(:,1,1)
-            ENDIF
-            IF ( dta%ll_u2d ) THEN
-               IF ( ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ dta%u2d allocated space'
-                  ALLOCATE( dta%u2d(nblen(2)) )
-               ELSE
-                  if(lwp) write(numout,*) '++++++ dta%u2d pointing to fnow'
-                  jfld = jfld + 1
-                  dta%u2d => bf(jfld)%fnow(:,1,1)
-               ENDIF
-            ENDIF
-            IF ( dta%ll_v2d ) THEN
-               IF ( ln_full_vel_array(jbdy) ) THEN
-                  if(lwp) write(numout,*) '++++++ dta%v2d allocated space'
-                  ALLOCATE( dta%v2d(nblen(3)) )
-               ELSE
-                  if(lwp) write(numout,*) '++++++ dta%v2d pointing to fnow'
-                  jfld = jfld + 1
-                  dta%v2d => bf(jfld)%fnow(:,1,1)
-               ENDIF
-            ENDIF
-         ENDIF
-
-         IF ( nn_dyn3d_dta(jbdy) == 0 ) THEN
-            if(lwp) write(numout,*) '++++++ dta%u3d/v3d allocated space'
-            IF( dta%ll_u3d ) ALLOCATE( dta_bdy(jbdy)%u3d(nblen(2),jpk) )
-            IF( dta%ll_v3d ) ALLOCATE( dta_bdy(jbdy)%v3d(nblen(3),jpk) )
-         ENDIF
-         IF ( nn_dyn3d_dta(jbdy) == 1 .or. &
-           &  ( ln_full_vel_array(jbdy) .and. ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) ) ) THEN
-            IF ( dta%ll_u3d .or. ( ln_full_vel_array(jbdy) .and. dta%ll_u2d ) ) THEN
-               if(lwp) write(numout,*) '++++++ dta%u3d pointing to fnow'
-               jfld = jfld + 1
-               dta_bdy(jbdy)%u3d => bf(jfld)%fnow(:,1,:)
-            ENDIF
-            IF ( dta%ll_v3d .or. ( ln_full_vel_array(jbdy) .and. dta%ll_v2d ) ) THEN
-               if(lwp) write(numout,*) '++++++ dta%v3d pointing to fnow'
-               jfld = jfld + 1
-               dta_bdy(jbdy)%v3d => bf(jfld)%fnow(:,1,:)
-            ENDIF
-         ENDIF
-
-         IF( nn_tra_dta(jbdy) == 0 ) THEN
-            if(lwp) write(numout,*) '++++++ dta%tem/sal allocated space'
-            IF( dta%ll_tem ) ALLOCATE( dta_bdy(jbdy)%tem(nblen(1),jpk) )
-            IF( dta%ll_sal ) ALLOCATE( dta_bdy(jbdy)%sal(nblen(1),jpk) )
-         ELSE
-            IF( dta%ll_tem ) THEN
-               if(lwp) write(numout,*) '++++++ dta%tem pointing to fnow'
-               jfld = jfld + 1
-               dta_bdy(jbdy)%tem => bf(jfld)%fnow(:,1,:)
-            ENDIF
-            IF( dta%ll_sal ) THEN 
-               if(lwp) write(numout,*) '++++++ dta%sal pointing to fnow'
-               jfld = jfld + 1
-               dta_bdy(jbdy)%sal => bf(jfld)%fnow(:,1,:)
-            ENDIF
-         ENDIF
-
-#if defined key_si3
-         IF (cn_ice(jbdy) /= 'none') THEN
-            IF( nn_ice_dta(jbdy) == 0 ) THEN
-               ALLOCATE( dta_bdy(jbdy)%a_i(nblen(1),jpl) )
-               ALLOCATE( dta_bdy(jbdy)%h_i(nblen(1),jpl) )
-               ALLOCATE( dta_bdy(jbdy)%h_s(nblen(1),jpl) )
-            ELSE
-               IF ( nice_cat == jpl ) THEN ! case input cat = jpl
-                  jfld = jfld + 1
-                  dta_bdy(jbdy)%a_i => bf(jfld)%fnow(:,1,:)
-                  jfld = jfld + 1
-                  dta_bdy(jbdy)%h_i => bf(jfld)%fnow(:,1,:)
-                  jfld = jfld + 1
-                  dta_bdy(jbdy)%h_s => bf(jfld)%fnow(:,1,:)
-               ELSE                        ! case input cat = 1 OR (/=1 and /=jpl)
-                  jfld_ait(jbdy)  = jfld + 1
-                  jfld_htit(jbdy) = jfld + 2
-                  jfld_htst(jbdy) = jfld + 3
-                  jfld     = jfld + 3
-                  ALLOCATE( dta_bdy(jbdy)%a_i(nblen(1),jpl) )
-                  ALLOCATE( dta_bdy(jbdy)%h_i(nblen(1),jpl) )
-                  ALLOCATE( dta_bdy(jbdy)%h_s(nblen(1),jpl) )
-                  dta_bdy(jbdy)%a_i(:,:) = 0._wp
-                  dta_bdy(jbdy)%h_i(:,:) = 0._wp
-                  dta_bdy(jbdy)%h_s(:,:) = 0._wp
-               ENDIF
-
-            ENDIF
-         ENDIF
-#endif
+               IF( llread ) THEN                                           ! get data from NetCDF file
+                  CALL fld_fill( bf_alias, bn_alias, cn_dir, 'bdy_dta', cl3//' '//ctmp1, ctmp2 )   ! use namelist info
+                  IF( bf_alias(1)%ln_tint ) ALLOCATE( bf_alias(1)%fdta( iszdim, 1, ipk, 2 ) )
+                  bf_alias(1)%imap    => idx_bdy(jbdy)%nbmap(1:iszdim,igrd)   ! associate the mapping used for this bdy
+                  bf_alias(1)%igrd    = igrd                                  ! used only for vertical integration of 3D arrays
+                  bf_alias(1)%ibdy    = jbdy                                  !  "    "    "     "          "      "  "    "    
+                  bf_alias(1)%ltotvel = ln_full_vel                           ! T if u3d is full velocity
+                  bf_alias(1)%lzint   = ln_zinterp                            ! T if it requires a vertical interpolation
+               ENDIF
+
+               ! associate the pointer and get rid of the dimensions with a size equal to 1
+               IF( jfld == jp_bdyssh )        dta_bdy(jbdy)%ssh => bf_alias(1)%fnow(:,1,1)
+               IF( jfld == jp_bdyu2d )        dta_bdy(jbdy)%u2d => bf_alias(1)%fnow(:,1,1)
+               IF( jfld == jp_bdyv2d )        dta_bdy(jbdy)%v2d => bf_alias(1)%fnow(:,1,1)
+               IF( jfld == jp_bdyu3d )        dta_bdy(jbdy)%u3d => bf_alias(1)%fnow(:,1,:)
+               IF( jfld == jp_bdyv3d )        dta_bdy(jbdy)%v3d => bf_alias(1)%fnow(:,1,:)
+               IF( jfld == jp_bdytem )        dta_bdy(jbdy)%tem => bf_alias(1)%fnow(:,1,:)
+               IF( jfld == jp_bdysal )        dta_bdy(jbdy)%sal => bf_alias(1)%fnow(:,1,:)
+               IF( jfld == jp_bdya_i ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%a_i => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%a_i(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdyh_i ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%h_i => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%h_i(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdyh_s ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%h_s => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%h_s(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdyt_i ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%t_i => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%t_i(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdyt_s ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%t_s => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%t_s(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdytsu ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%tsu => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%tsu(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdys_i ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%s_i => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%s_i(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdyaip ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%aip => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%aip(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+               IF( jfld == jp_bdyhip ) THEN
+                  IF( ipk == jpl ) THEN   ;   dta_bdy(jbdy)%hip => bf_alias(1)%fnow(:,1,:)
+                  ELSE                    ;   ALLOCATE( dta_bdy(jbdy)%hip(iszdim,jpl) )
+                  ENDIF
+               ENDIF
+            ENDIF
+
+         END DO   ! jpbdyfld
          !
       END DO ! jbdy 
       !
    END SUBROUTINE bdy_dta_init
-
+   
    !!==============================================================================
 END MODULE bdydta
